myapp/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('neo/', include('neo.urls')),
    path('users/', include('users.urls')),
]

neo/urls.py
from django.urls import path
from . import views

app_name = 'neo'

urlpatterns = [
    path('', views.index, name='index'),
    path('<int:question_id>/', views.detail, name='detail'),
    path('<int:question_id>/results/', views.results, name='results'),
    path('<int:question_id>/vote/', views.vote, name='vote'),
]

users/urls.py
from django.urls import path
from . import views

app_name = 'users'

urlpatterns = [
    path('login/', views.login_view, name='login'),
    path('logout/', views.logout_view, name='logout'),
]

neo/models.py
import datetime

from django.db import models
from django.utils import timezone

# Create your models here.
class Question(models.Model):
    question_text = models.CharField(max_length=210)
    pub_date = models.DateTimeField('date published')

    def __str__(self):
        return self.question_text

    def was_published_recently(self):
        now = timezone.now()
        return now - datetime.timedelta(days=1) <= self.pub_date <= now
    was_published_recently.short_description = 'Published Recently?'

class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self):
        return self.choice_text

users/models.py
from django.db import models

# Create your models here.

neo/views.py
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.shortcuts import get_object_or_404, render
from django.urls import reverse
from django.utils import timezone

from .models import Choice, Question

# Create your views here.
@login_required
def index(request):
    questions = Question.objects.filter(
        pub_date__lte=timezone.now()).order_by('-pub_date')[:5]
    context = {
        'last_questions': questions,
    }
    return render(request, 'neo/home.html', context)

@login_required
def detail(request, question_id):
    question = Question.objects.get(pk=question_id)
    return render(request, 'neo/detail.html', {'question': question})

@login_required
def results(request, question_id):
    question = Question.objects.get(pk=question_id)
    return render(request, 'neo/results.html', {'question': question})

def vote(request, question_id):
    question = get_object_or_404(Question, pk=question_id)
    try:
        choice_selected = question.choice_set.get(pk=request.POST['choice'])
    except (KeyError, Choice.DoesNotExist):
        return render(request, 'neo/detail.html', {
            'question': question,
            'error_message': 'You didn\'t select a choice',
        })
    else:
        choice_selected.votes += 1
        choice_selected.save()
        
        return HttpResponseRedirect(reverse('neo:results', args=(question_id,)))

users/views.py
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login, logout

# Create your views here.
def login_view(request):
    if request.method == 'POST':
        username = request.POST['username']
        password = request.POST['password']
        user = authenticate(request=request, username=username, password=password)
        if user is not None:
            login(request, user)
            return redirect('neo:index')
        else:
            return render(request, 'users/login.html', {
                'error_message': 'Invalid user name or password',
            })
    return render(request, 'users/login.html')

def logout_view(request):
    logout(request)
    return redirect('users:login')

templates/neo/detail.html
{% extends 'neo/index.html' %}

{% block headcontent %}
  <title>Detail | neosurvival</title>
{% endblock headcontent %}

{% block body %}
  <h1>{{ question.question_text }}</h1>

  {% if error_message %}<div class="alert alert-danger">{{ error_message }}</div>{% endif %}

  <form action="{% url 'neo:vote' question.id %}" method="post">
    {% csrf_token %}
    {% for choice in question.choice_set.all %}
      <div class="form-group">
        <input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{choice.id}}">
        <label for="choice{{ forloop.counter }}">{{ choice.choice_text}}</label>
      </div>
    {% endfor %}
    <input class="btn btn-success" type="submit" value="Vote">
    <a href="{% url 'neo:index' %}" class="btn btn-primary">Home</a>
  </form>
{% endblock body %}

templates/neo/home.html
{% extends 'neo/index.html' %}

{% block headcontent %}
  <title>Index | neosurvival</title>
{% endblock headcontent %}

{% block body %}
  {% if last_questions %} 
    <ul class="list-group">
      {% for question in last_questions %}
        <li class="list-group-item"><a class="green" href="{% url 'neo:detail' question.pk %}" >{{question.question_text}}</a></li>
      {% endfor %}
    </ul>
  {% endif %}
{% endblock body %}

templates/neo/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    {% load static %}
    <link rel="shortcut icon" href="{% static 'favicon.ico' %}" type="image/x-icon">
    <link rel="stylesheet" type="text/css" href="{% static 'neo/style.css' %}">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    {% block headcontent %}
    {% endblock headcontent %}
</head>
<body>
  {% include './navbar.html' %}
  <div class="container mt-5">
    <div class="row">
      <div class="col">
          {% block body %}
          {% endblock body %}
      </div>
    </div>
  </div>
</body>
</html>

templates/neo/navbar.html
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <a class="navbar-brand" href="#">{{name}}</a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <li class="nav-item active">
        <a class="btn btn-outline-light my-2 my-sm-0" href="{% url 'neo:index' %}">Home <span class="sr-only">(current)</span></a>
      </li>
    </ul>
      <form class="form-inline my-2 my-lg-0">
      <a class="btn btn-outline-light my-2 my-sm-0" href="{% url 'users:logout' %}">Log out</a>
    </form
  </div>
</nav>

templates/neo/results.html
{% extends 'neo/index.html' %}

{% block headcontent %}
  <title>Results | neosurvival</title>
{% endblock headcontent %}

{% block body %}
  <h1>{{ question.question_text }}</h1>

  <ul class="list-group">
    {% for choice in question.choice_set.all %}
      <li class="list-group-item">{{choice.choice_text}} -- {{choice.votes}} vote{{ choice.votes|pluralize }}</li>
    {% endfor %}
  </ul>
  <br>
  <a class="btn btn-success" href="{% url 'neo:detail' question.id %}">Vote again?</a>
{% endblock body %}

templates/users/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    {% load static %}
    <link rel="shortcut icon" href="{% static 'favicon.ico' %}" type="image/x-icon">
    <link rel="stylesheet" type="text/css" href="{% static 'neo/style.css' %}">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    {% block headcontent %}
    {% endblock headcontent %}
</head>
<body>
  <br>
  <div class="container">
    <div class="row">
      <div class="col">
          {% block body %}
          {% endblock body %}
      </div>
    </div>
  </div>
</body>
</html>

templates/users/login.html
{% extends './index.html' %}

{% block headcontent %}
  <title>Login | neosurvival</title>
{% endblock headcontent %}

{% block body %}
  {% if error_message %}<div class="alert alert-danger">{{ error_message }}</div>{% endif %}
  <form action="{% url 'users:login' %}" method="post">
      {% csrf_token %}
      <div class="form-group">
          <input type="text" name="username" id="username-login" placeholder="User name">
          <br>
          <input type="password" name="password" id="password-login" placeholder="Password">
      </div>
      <div class="form-group">
          <input class="btn btn-primary" type="submit" value="Log in">
      </div>
  </form>
{% endblock body %}